﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_richtextbox_image
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            rtbQuote.Text = "Outside of a dog, a book is man's best friend. Inside of a dog it's too dark to read.";
            rtbQuote.Select(18, 27);
            rtbQuote.SelectionColor = Color.Blue;
            rtbQuote.Select(20, 4);
            rtbQuote.SelectionFont = new Font(rtbQuote.Font, FontStyle.Italic);
            rtbQuote.Select(63, 21);
            rtbQuote.SelectionColor = Color.Red;
            rtbQuote.SelectionFont = new Font(rtbQuote.Font, FontStyle.Bold);
            rtbQuote.Select(0, 0);
        }

        private void btnCapture_Click(object sender, EventArgs e)
        {
            picResult.Image = RtbToBitmap(rtbQuote);
            picResult.Visible = true;
        }

        
        // See: how to save the content of richTextBox as jpg file?
        // https://social.msdn.microsoft.com/Forums/en-US/1454d078-c312-4741-88df-aa7eb306fe51/how-to-save-the-content-of-richtextbox-as-jpg-file?forum=winforms
        public Bitmap RtbToBitmap(RichTextBox rtb)
        {
            // Make sure the RichTextBox is fully painted.
            rtb.Update();

            // Get the image.
            int width = rtb.ClientSize.Width;
            int height = rtb.ClientSize.Height;
            Bitmap bmp = new Bitmap(width, height);
            using (Graphics gr = Graphics.FromImage(bmp))
            {
                gr.CopyFromScreen(
                    rtb.PointToScreen(new Point(0, 0)),
                    new Point(0, 0), rtb.ClientSize);
            }
            return bmp;
        }
    }
}
